# -*- coding: utf-8 -*-
from setuphelpers import *
import subprocess

r"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()

"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def install():
    # Declaring local variables
    bin_name = glob.glob('QMPlay2-*.exe')[0]
    # Installing the software

    subprocess.Popen(bin_name + " --Auto",creationflags=subprocess.CREATE_NEW_CONSOLE)
    wait_process_finish(bin_name)
    wait_uninstallkey_present(name="QMPlay2")
    killalltasks(ensure_list(bin_name,"QMPlay2.exe"))


def uninstall():
    # Uninstalling older versions of the software
    for to_uninstall in installed_softwares(name="QMPlay2"):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        run(uninstall_cmd(to_uninstall["key"]))
        wait_uninstallkey_absent(to_uninstall["key"])
        if isdir(to_uninstall["install_location"]):
            remove_tree(to_uninstall["install_location"])


def wait_process_finish(process_name, timeout=120):
    current_time = 0
    while find_processes(process_name):
        current_time += 1
        if current_time > timeout:
            return
        time.sleep(1)




